; #==========Mode:MPASM Assembler

		LIST P=16F84A
		include		"p16F84A.inc"

 __CONFIG _WDT_ON&_XT_OSC&_CP_OFF&_PWRTE_ON
 __IDLOCS 1234h

PC				EQU		H'0002'
status			EQU		H'0003'
PORTA			EQU		H'0005'
PORTB			EQU		H'0006'
counter			EQU		H'000C'
n_bits			EQU		H'000D'
recv_reg		EQU		H'000E'
n_bytes			EQU		H'000F'
flag_store		EQU		H'0010'
com_byte_1		EQU		H'0012'
com_byte_2		EQU		H'0013'
com_sent_ctr	EQU		H'0014'
send_reg		EQU		H'0015'
key_temp		EQU		H'0016'
key_store		EQU		H'0017'
key_debounce	EQU		H'0018'
flag_rec		EQU		H'0019'
counter2		EQU		H'0020'
blink_count		EQU		H'0021'
VTR_status		EQU		H'0022'
counter3		EQU		H'0023'
cold_start_counter	EQU		H'0024'

;***********************************************************************
;
;  Equates for this program
;
;***********************************************************************
; bits
;lanc           equ  4h   ; bit 4 of port a

;lanc_byte      equ  2h   ; bit 2 of port a  (Debugging output pin)
;rec_led        equ  1h   ; bit 1 of port a  (Rec_Led output pin)
;rec_input      equ  0h   ; bit 0 of port a  (Rec input pin)

; byte flag_store :
;seventh_byte   equ  0h   ; flag to indicate that this is the 7 of 8 byt
;command_waiting equ  1h  ; flag to indicate command waiting
;command_tx     equ  2h   ; flag to indicate ready to transmit command
;key_pressed    equ  3h   ; flag to indicate that a key has been pressed
;key_repeats    equ  4h   ; flag to indicate that key repeats

; byte flag_rec :
RecOn			equ 01h   ; flag to indicate that recording is on
blink_flag		equ 00h   ;  blink is request
led_on_flag		equ 03h		; flag  blink  on/off at 1 Hz


; byte VTR_status /	
stop_flag		equ 02h   ; flag 
low_bat_flag	equ 03h
rec_flag		equ 04h
tape_end_flag	equ	05h
cold_start_flag	equ 06h		; indicate cold start
rec_pause		equ	07h		; 0=stop, 1=rec_pause




		ORG		H'00000'

; init 
		

		BCF		status,6
		BSF		status,5	; Must set RP0 to access bank 1

		MOVLW		H'0001'	; Set PortA pins (lanc out)
		MOVWF		PORTA
		MOVLW		H'00FF'	; Set PortB pins
		MOVWF		PORTB
		bcf     OPTION_REG,7 ; portB pull-up on
		BSF		OPTION_REG,3 ; enable prescaler for WDT
		BSF		OPTION_REG,2 ; ratio prescaler for WDT
		BSF		OPTION_REG,1 ; ratio prescaler for WDT
		BCF		OPTION_REG,0 ; ratio prescaler for WDT
		BCF		STATUS,5	; return to bank 0


Power_on ; starting VTR
		CLRWDT					; reset watchdog
		BTFSS		PORTB,4
		GOTO		Power_on	; wait until line 'power_on' is on

	  	  bcf	    PORTA,4     ; lanc shorted to gnd
          bsf       PORTA,1		; led on
		  movlw	    .255		; 255 x 765 uS
		  movwf	    counter2
		  movlw	    .255
c2		  movwf	    counter		; 255 x 3uS
c1  	  decfsz    counter,1	; 1 uS
		  goto      c1			; 2 uS
 	  	  decfsz    counter2,1	; 
 		  goto      c2		
          bcf       PORTA,1		; led off
	  	  bsf	    PORTA,4     ; lanc release
		

; boucle attente initialisation VTR

 		movlw	  .25		; 25 x 20 mS
		movwf	  counter3
c5 		  movlw	    .255		; 255 x 765 uS
		  movwf	    counter2
		  clrwdt				; reset watchdog
c4		  	movlw	    .255
		 	movwf	    counter		; 255 x 3uS
c3  		          decfsz    counter,1	; 1 uS
			goto      c3		; 2 uS
 	  	  decfsz    counter2,1	; 
 		  goto      c4		
 	  	decfsz    counter3,1	; 
 		goto      c5	
	
; init2 ...to send 7 times "datascreen" at startup
		
		BSF			VTR_status,cold_start_flag 	
		MOVLW		H'0008'
		MOVWF		cold_start_counter

eror
		BCF		status,6
		BSF		status,5
		MOVLW		H'0011'
		MOVWF		PORTA
		MOVLW		H'00FF'
		MOVWF		PORTB
		BCF		status,5


;		BSF		PORTA,1	; led on
;		CLRF	flag_rec

sync_up 							; main loop
		CLRF		counter

sync_loop
		BTFSS		PORTA,4
		GOTO		sync_up
		NOP		
		INCFSZ		counter,1
		GOTO		sync_loop
;sinced
		CLRF		n_bytes
		BCF		flag_store,0


wait_strt
		BTFSC		PORTA,4
		GOTO		wait_strt
		MOVLW		H'000F' ;start_bit
		MOVWF		counter

L1
		DECFSZ		counter,1
		GOTO		L1
		BTFSC		PORTA,4
		GOTO		eror
		BSF		PORTA,2
		BCF		PORTA,2
		MOVLW		H'0008' ; 8bits
		MOVWF		n_bits

wait_bits
		MOVLW		H'000F'
		MOVWF		counter

L2
		DECFSZ		counter,1
		GOTO		L2
		BSF		PORTA,2
		BCF		PORTA,2
;send_bit
		BTFSS		flag_store,2
		GOTO		wait_half
		BTFSS		send_reg,0
		GOTO		send_0
;send_1
		BCF		PORTA,4
		BSF		status,5
		MOVLW		H'0001'
		MOVWF		PORTA
		BCF		status,5
		NOP		
		GOTO		sent_bit

send_0
		BSF		PORTA,4
		BSF		status,5
		MOVLW		H'0011'
		MOVWF		PORTA
		BCF		status,5
		NOP		
		NOP	

sent_bit
		RRF		send_reg,1
		MOVLW		H'000A'
		GOTO		jump_half

wait_half
		MOVLW		H'000E'

jump_half
		MOVWF		counter

L3
		DECFSZ		counter,1
		GOTO		L3
;read_bits
		RRF		recv_reg,1
		BCF		recv_reg,7
		BTFSS		PORTA,4
		BSF		recv_reg,7
		BSF		PORTA,2
		BCF		PORTA,2
		DECFSZ		n_bits,1
		GOTO		wait_bits
;wait_stop
		MOVLW		H'000E'
		MOVWF		counter

L4
		DECFSZ		counter,1
		GOTO		L4
		BSF		PORTA,2
		BCF		PORTA,2
;send_stop
		BTFSS		flag_store,2
		GOTO		wait_half_stop
		BSF		PORTA,4
		BSF		status,5
		MOVLW		H'0011'
		MOVWF		PORTA
		BCF		status,5
		BCF		flag_store,2
		MOVLW		H'000B'
		GOTO		jump_half_stop

wait_half_stop
		MOVLW		H'000E'

jump_half_stop
		MOVWF		counter

L5
		DECFSZ		counter,1
		GOTO		L5

;read_stop
		BTFSS		PORTA,4
		GOTO		eror
		BSF		PORTA,2
		BCF		PORTA,2

;count
		INCF		n_bytes,1
		DECF		n_bytes,0
		ANDLW		H'0007'
		ADDWF		PC,1
		GOTO		check_0
		GOTO		check_1
		GOTO		check_2
		GOTO		check_3
		GOTO		check_4
		GOTO		check_5
		GOTO		check_6
		GOTO		check_7

check_0
		BSF		PORTA,2
		BCF		PORTA,2
		BTFSS		flag_store,1
		GOTO		end_0
		MOVF		com_byte_2,0
		MOVWF		send_reg
		BSF		flag_store,2

end_0
		GOTO		wait_strt

check_1
		GOTO		wait_strt

check_2
		GOTO		wait_strt

check_3
		GOTO		wait_strt

check_4

		MOVLW		H'0002'
		SUBWF		recv_reg,0
		BTFSC		status,2    
		BSF			VTR_status,2	;stop
		BTFSS		status,2
		BCF			VTR_status,2	;stop

		MOVLW		H'0004'
		SUBWF		recv_reg,0
		BTFSC		status,2    
		BSF			VTR_status,rec_flag	;rec
		BTFSS		status,2
		BCF			VTR_status,rec_flag	;rec

		MOVLW		H'0014'
		SUBWF		recv_reg,0
		BTFSC		status,2
		BSF			VTR_status,7	;Rec/pause mode
		BTFSS		status,2
		BCF			VTR_status,7	;Rec/pause mode

;		MOVLW		H'0032'			;low_bat
;		SUBWF		recv_reg,0
;		BTFSC		status,2
;		BSF			flag_rec,blink_flag	
		

;		MOVLW		H'0062'			;tape_end (not tape pre-end)
;		SUBWF		recv_reg,0
;		BTFSC		status,2
;		BSF			flag_rec,blink_flag	

; blink_flag is reset every 20H frames (blink counter)
; useful if status 'record' and status 'low_bat' are multiplexed
		GOTO		wait_strt

check_5

; some models use Byte 4, some use Byte 5 for tape pre-end and low bat

		BTFSC		recv_reg,1 	; tape_end
		BSF			flag_rec,blink_flag	

		BTFSC		recv_reg,2 	; low bat
		BSF			flag_rec,blink_flag	

; blink_flag is reset every 20H frames (blink counter)
		GOTO		wait_strt

check_6
		GOTO		wait_strt

check_7
		CLRF		n_bytes
		CALL		Key_Scan
		BTFSC		flag_store,3
		CALL		Command_Decode
		DECFSZ		com_sent_ctr,1
		GOTO		mid_7
		MOVLW		H'0001'
		MOVWF		com_sent_ctr
		BCF		flag_store,1
		BCF		flag_store,2
		GOTO		end_7

mid_7
		MOVF		com_byte_1,0
		MOVWF		send_reg
		BSF		flag_store,1
		BSF		flag_store,2

end_7 ; here we have time to do many things....

;***************
		clrwdt ; watch-dog cleared in main loop every 20 mS

blink1 	DECFSZ		blink_count,1
		GOTO 		blink1_fin

blink1_suite
		MOVLW		H'0020' ; load counter value
		MOVWF		blink_count

		MOVLW		H'0008' ; XOR on 4th bit
		XORWF	  	flag_rec,led_on_flag	; et on inverse led_on
		BCF			flag_rec,blink_flag	; reset blink flag

blink1_fin
;**************


led_rec	
		btfss 	VTR_status,rec_flag	;if rec ->led may be on
		goto led_off

		BTFSS		flag_rec,blink_flag ; blink ?
		GOTO 		led_on

		BTFSC		flag_rec,led_on_flag ; blink !
		GOTO 		led_on
		GOTO		led_off

led_on
		
		BSF		PORTA,1
		GOTO 	end_led
led_off
		BCF		PORTA,1
end_led

		GOTO		sync_up				; end main loop

;**********************************************

Command_Decode
		MOVWF		key_temp
		ANDLW		H'000F' ; mask to prevent table overrun
		ADDWF		PC,1 	; jump into table
		GOTO		Datascreen
		GOTO		Record
		GOTO		Pause
		GOTO		Stop
		GOTO		Power_off
		GOTO		Power_off
		

Datascreen		; 0
		MOVLW		H'0018'		; data to VTR
		MOVWF		com_byte_1
		MOVLW		H'00B4' 	; dataScreen
		MOVWF		com_byte_2
		GOTO		end_command

Record
		MOVLW		H'0018'		; data to VTR
		MOVWF		com_byte_1
		MOVLW		H'003A'		; record
		MOVWF		com_byte_2
		GOTO		end_command

Pause			; 2
		MOVLW		H'0018'		; data to VTR
		MOVWF		com_byte_1
		MOVLW		H'0032'		; pause (3C au lieu de 32)
		MOVWF		com_byte_2
		GOTO		end_command

Stop			; 3
		MOVLW		H'0018'		; data to VTR
		MOVWF		com_byte_1
		MOVLW		H'0030'		; Stop
		MOVWF		com_byte_2
		GOTO		end_command

Power_off
		MOVLW		H'0018'
		MOVWF		com_byte_1
		MOVLW		H'005E'
		MOVWF		com_byte_2	; Power_off
		GOTO		end_command


end_command
		MOVLW		H'0006' ; send command over 5 fields
		MOVWF		com_sent_ctr
		RETURN		


;*********************************************

Key_Scan
		BCF		flag_store,3

		BTFSC		PORTB,4		; scan input RB4
		GOTO		end_power

		MOVLW		H'0004' 	;power_off
		MOVWF		key_temp
		BSF		flag_store,3	;key pressed
;		bsf		flag_store,2	;command_tx
;		bsf		flag_store,1	;command_waiting

		GOTO		end_scan
end_power

;------------------------------------------------------
; cold start

		BTFSS		VTR_status,cold_start_flag
		GOTO		end_cold_start

		MOVLW		H'0000'
		MOVWF		key_temp
		BSF			flag_store,3	;key_pressed
		DECFSZ		cold_start_counter,1
		GOTO		end_scan
		BCF			VTR_status,cold_start_flag
		GOTO		end_scan

end_cold_start
;------------------------------------------------------

		BTFSS		PORTA,0		; scan input RA0
		GOTO		stop_pause	; record  off
		GOTO		record		; record  on

record
		BTFSC	VTR_status,rec_flag	; 
		GOTO	end_scan			; 

		BTFSC	VTR_status,rec_pause	; 
		GOTO	send_pause			; 
		GOTO	send_rec			; sinon


stop_pause
; this one verifie status STOP, 
; external rewind, play, etc impossible
;		BTFSC	VTR_status,stop_flag	; stop ?
;		GOTO	end_scan				; Ok
;		GOTO	check_line_pause
;***************
; this one verifie status (no-rec) and (no-pause), 
; external rewind, play, possible
		BTFSC	VTR_status,rec_flag	; non rec ?
		GOTO	check_line_pause	; 
		BTFSS	VTR_status,rec_pause ; non pause ?
		GOTO	end_scan
;***************
check_line_pause
		BTFSC	PORTB,3				; line pause active ?
		GOTO	send_stop			

		BTFSS	VTR_status,rec_pause	; deja en rec_pause ?
		GOTO	send_pause				; ok
		GOTO	end_scan



send_rec
		MOVLW		H'0001'
		MOVWF		key_temp
		BSF			flag_store,3	;key_pressed
		GOTO		end_scan

send_pause
		MOVLW		H'0002'
		MOVWF		key_temp
		BSF			flag_store,3	;key_pressed
		GOTO		end_scan

send_stop
		MOVLW		H'0003'
		MOVWF		key_temp
		BSF			flag_store,3	;key_pressed
		GOTO		end_scan

end_scan
		MOVF		key_temp,0
		RETURN		
		
		END		
